//
//  NSManagedObject+SyncKitAdditions.m
//  SyncKit
//
//  Created by Logan Collins on 4/16/13.
//  Copyright (c) 2013 Sunflower Softworks. All rights reserved.
//

#import "NSManagedObject+SyncKitAdditions.h"

#import "SNKProperty.h"
#import "SNKAttribute.h"
#import "SNKRelationship.h"

#import "NSEntityDescription+SyncKitAdditions.h"
#import "SNKPersistentSyncCoordinator.h"

#import "SyncKitErrors.h"


@implementation NSManagedObject (SyncKitAdditions)

- (NSString *)snk_syncableIdentifier {
    NSString *attributeName = [[self entity] snk_syncableIdentifierAttributeName];
    id value = [self valueForKey:attributeName];
    if (value == nil) {
        //@throw [NSException exceptionWithName:NSInvalidArgumentException reason:@"Syncable identifier cannot be nil" userInfo:nil];
    }
    return value;
}

- (void)snk_setSyncableIdentifier:(NSString *)identifier {
    NSString *attributeName = [[self entity] snk_syncableIdentifierAttributeName];
    [self setValue:identifier forKey:attributeName];
}

@end
