//
//  SNKChangeObject_Private.h
//  SyncKit
//
//  Created by Logan Collins on 10/26/13.
//  Copyright (c) 2013 Sunflower Softworks. All rights reserved.
//

#import <SyncKit/SNKChangeObject.h>
#import <CoreData/CoreData.h>


@interface SNKChangeObject ()

// Initializes a class from a given Core Data entity, synthesizing dynamic implementations for missing methods.
+ (void)initializeWithEntity:(NSEntityDescription *)entity;

+ (instancetype)objectWithManagedObject:(NSManagedObject *)managedObject context:(SNKChangeContext *)context;

- (id)initWithManagedObject:(NSManagedObject *)managedObject context:(SNKChangeContext *)context;

@property (SYNCKIT_WEAK_ARC_ONLY, readwrite) SNKChangeContext *context;
@property (strong) NSManagedObject *managedObject;

- (id)managedValueForKey:(NSString *)key;
- (void)setManagedValue:(id)value forKey:(NSString *)key;

@end


@interface NSManagedObject (SNKChangeObjectAdditions)

- (SNKChangeObject *)snk_changeObject;
- (void)snk_setChangeObject:(SNKChangeObject *)object;

@end


@interface NSEntityDescription (SNKChangeObjectAdditions)

- (Class)snk_changeObjectClass;

@end
