//
//  SNKAccount.m
//  SyncKit
//
//  Created by Logan Collins on 4/22/13.
//  Copyright (c) 2013 Sunflower Softworks. All rights reserved.
//

#import "SNKAccount.h"
#import "SNKAccount_Private.h"

#import "SNKClient_Private.h"


@implementation SNKAccount

- (id)initWithDictionary:(NSDictionary *)dictionary {
    self = [super init];
    if (self) {
        self.identifier = dictionary[@"identifier"];
        self.email = dictionary[@"email"];
        
        NSDictionary *clientsDict = dictionary[@"clients"];
        NSMutableDictionary *clientsByApplication = [NSMutableDictionary dictionaryWithCapacity:[clientsDict count]];
        for (NSString *applicationIdentifier in clientsDict) {
            NSArray *clientDicts = clientsDict[applicationIdentifier];
            NSMutableArray *clients = [NSMutableArray arrayWithCapacity:[clientDicts count]];
            for (NSDictionary *clientDict in clientDicts) {
                SNKClient *client = [[SNKClient alloc] initWithDictionary:clientDict];
                [clients addObject:client];
            }
            clientsByApplication[applicationIdentifier] = clients;
        }
        self.clientsByApplication = clientsByApplication;
    }
    return self;
}

@end
