//
//  SNKClient.h
//  SyncKit
//
//  Created by Logan Collins on 4/5/13.
//  Copyright (c) 2013 Sunflower Softworks. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <SyncKit/SyncKitDefines.h>


typedef SYNCKIT_ENUM(NSUInteger, SNKClientType) {
    SNKClientTypeUnknown = 0,
    SNKClientTypeiOS,
    SNKClientTypeMac,
};


@interface SNKClient : NSObject

@property (copy, readonly) NSString *identifier;

@property (copy, readonly) NSString *name;
@property (readonly) SNKClientType type;
@property (copy, readonly) NSString *model;

@property (copy, readonly) NSString *systemVersion;
@property (copy, readonly) NSString *localeIdentifier;

@property (copy, readonly) NSString *applicationIdentifier;
@property (copy, readonly) NSString *applicationName;
@property (copy, readonly) NSString *applicationVersion;

@property (copy, readonly) NSDictionary *iconsDictionary;

@property (copy, readonly) NSDate *lastSyncDate;

@end
