//
//  SNKAttribute.h
//  SyncKit
//
//  Created by Logan Collins on 12/19/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import <SyncKit/SNKProperty.h>
#import <SyncKit/SyncKitDefines.h>


typedef SYNCKIT_ENUM(NSUInteger, SNKAttributeType) {
    SNKAttributeTypeUndefined   = 0,    // Undefined
    SNKAttributeTypeInteger     = 100,  // NSNumber
    SNKAttributeTypeFloat       = 200,  // NSNumber
    SNKAttributeTypeDecimal     = 300,  // NSDecimalNumber
    SNKAttributeTypeBoolean     = 400,  // NSNumber
    SNKAttributeTypeString      = 500,  // NSString
    SNKAttributeTypeDate        = 600,  // NSDate
    SNKAttributeTypeBinaryData  = 700,  // NSData
};


@interface SNKAttribute : SNKProperty

+ (SNKAttribute *)attributeWithName:(NSString *)name type:(SNKAttributeType)type value:(id)value;

@property SNKAttributeType type;
@property (copy) id value;

@end
