//
//  SNKProperty.m
//  SyncKit
//
//  Created by Logan Collins on 12/19/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "SNKProperty.h"
#import "SNKProperty_Private.h"


@implementation SNKProperty

- (id)init {
    if ([self class] == [SNKProperty class]) {
        @throw [NSException exceptionWithName:NSInvalidArgumentException reason:@"SNKProperty is an abstract class and should not be initialized directly." userInfo:nil];
    }
    else {
        return [super init];
    }
}

- (id)initWithDictionary:(NSDictionary *)dictionary {
    if ([self class] == [SNKProperty class]) {
        @throw [NSException exceptionWithName:NSInvalidArgumentException reason:@"SNKProperty is an abstract class and should not be initialized directly." userInfo:nil];
    }
    
    self = [super init];
    if (self) {
        self.name = dictionary[@"name"];
    }
    return self;
}

- (id)copyWithZone:(NSZone *)zone {
    SNKProperty *property = [[[self class] allocWithZone:zone] init];
    property.name = self.name;
    return property;
}

- (NSDictionary *)dictionaryRepresentation {
    NSMutableDictionary *dictionary = [NSMutableDictionary dictionary];
    
    dictionary[@"name"] = self.name;
    
    return dictionary;
}

@end
