//
//  SNKRecord.h
//  SyncKit
//
//  Created by Logan Collins on 12/19/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <SyncKit/SyncKitDefines.h>


@class SNKProperty;


@interface SNKRecord : NSObject <NSCopying>

@property (copy) NSString *identifier;
@property (copy) NSString *entityName;

@property (getter=isDeleted) BOOL deleted;
@property (copy) NSDate *deletionDate;

@property (copy) NSArray *properties;
- (SNKProperty *)propertyWithName:(NSString *)name;

- (void)addProperty:(SNKProperty *)property;
- (void)addProperties:(NSArray *)properties;
- (void)removePropertyWithName:(NSString *)name;

- (NSDictionary *)propertiesByName;
- (NSDictionary *)attributesByName;
- (NSDictionary *)relationshipsByName;

@property (copy) NSDate *creationDate;
@property (copy) NSDate *modificationDate;

@end
