//
//  SNKRelationship.m
//  SyncKit
//
//  Created by Logan Collins on 12/19/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "SNKRelationship.h"
#import "SNKRelationship_Private.h"

#import "SNKProperty_Private.h"


@implementation SNKRelationship

- (id)initWithDictionary:(NSDictionary *)dictionary {
    self = [super initWithDictionary:dictionary];
    if (self) {
        self.toMany = [dictionary[@"is_tomany"] boolValue];
        self.ordered = [dictionary[@"is_ordered"] boolValue];
        self.identifiers = dictionary[@"identifiers"];
    }
    return self;
}

- (id)copyWithZone:(NSZone *)zone {
    SNKRelationship *relationship = [super copyWithZone:zone];
    relationship.toMany = self.toMany;
    relationship.ordered = self.ordered;
    relationship.identifiers = self.identifiers;
    return relationship;
}

- (NSString *)description {
    return [NSString stringWithFormat:@"%@ { name='%@', toMany=%@, ordered=%@, identifiers=%@ }", [super description], self.name, (self.toMany ? @"YES" : @"NO"), (self.ordered ? @"YES" : @"NO"), self.identifiers];
}

- (NSDictionary *)dictionaryRepresentation {
    NSMutableDictionary *dictionary = [[super dictionaryRepresentation] mutableCopy];
    
    dictionary[@"is_tomany"] = @(self.toMany);
    dictionary[@"is_ordered"] = @(self.ordered);
    if (self.identifiers != nil) {
        dictionary[@"identifiers"] = self.identifiers;
    }
    else {
        dictionary[@"identifiers"] = @[];
    }
    
    return dictionary;
}

@end
