//
//  SNKRequest_Private.h
//  SyncKit
//
//  Created by Logan Collins on 1/2/13.
//  Copyright (c) 2013 Sunflower Softworks. All rights reserved.
//

#import <SyncKit/SNKRequest.h>
#import <SyncKit/SyncKitDefines.h>


typedef SYNCKIT_ENUM(NSUInteger, SNKRequestMethod) {
    SNKRequestMethodGET,
    SNKRequestMethodPOST,
    SNKRequestMethodDELETE,
};


typedef SYNCKIT_ENUM(NSUInteger, SNKRequestAuthorizationType) {
    SNKRequestAuthorizationTypeNone = 0,
    SNKRequestAuthorizationTypeOAuth,
};


@class SNKService, SNKCredentials;


@interface SNKRequest : NSObject <NSCopying, SNKRequest>

+ (SNKRequest *)requestWithSyncService:(SNKService *)service URL:(NSURL *)URL requestMethod:(SNKRequestMethod)requestMethod authorizationType:(SNKRequestAuthorizationType)authorizationType credentials:(SNKCredentials *)credentials parameters:(NSDictionary *)parameters;

@property (weak, readonly) SNKService *syncService;
@property (copy, readonly) NSURL *URL;
@property (readonly) SNKRequestMethod requestMethod;
@property (readonly) SNKRequestAuthorizationType authorizationType;
@property (strong, readonly) SNKCredentials *credentials;
@property (copy, readonly) NSDictionary *parameters;

- (void)scheduleWithCompletionHandler:(void (^)(NSHTTPURLResponse *response, NSData *responseData, NSError *error))handler;
- (void)cancel;

@end


SYNCKIT_EXTERN NSString * const SNKRequestDidFinishNotification;
