//
//  SNKSyncSession_Private.h
//  SyncKit
//
//  Created by Logan Collins on 1/15/13.
//  Copyright (c) 2013 Sunflower Softworks. All rights reserved.
//

#import <SyncKit/SNKSyncSession.h>


@class SNKService;


@interface SNKSyncSession ()

- (id)initWithSyncService:(SNKService *)service schema:(NSString *)schema delegate:(id <SNKSyncSessionDelegate>)delegate options:(NSDictionary *)options;

@property (copy, readwrite) NSString *schema;
@property (unsafe_unretained, readwrite) id <SNKSyncSessionDelegate> delegate;

@property (strong) SNKService *syncService;
@property (copy) NSDictionary *options;

@property (readwrite, getter=isSyncing) BOOL syncing;

- (void)start;

@property (readwrite) NSUInteger numberOfRecordsPushed;
@property (readwrite) NSUInteger numberOfRecordsPulled;

@end
