//
//  SNKDebug.h
//  SyncKit
//
//  Created by Logan Collins on 3/30/13.
//  Copyright (c) 2013 Sunflower Softworks. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <SyncKit/SyncKitDefines.h>


SYNCKIT_EXTERN BOOL SNKDebugLoggingIsEnabled();
SYNCKIT_EXTERN void SNKDebugLoggingSetEnabled(BOOL enabled);


#if defined(DEBUG) && DEBUG

#define SNKDebugLog(...) NSLog(@"DEBUG: %@", [NSString stringWithFormat:__VA_ARGS__]);
#define SNKMethodDebugLog(...) NSLog(@"DEBUG: %@:%@, %@", [self class], NSStringFromSelector(_cmd), [NSString stringWithFormat:__VA_ARGS__]);

#else

#define SNKDebugLog(...) \
if (SNKDebugLoggingIsEnabled()) { \
    NSLog(@"DEBUG: %@", [NSString stringWithFormat:__VA_ARGS__]); \
}

#define SNKMethodDebugLog(...) \
if (SNKDebugLoggingIsEnabled()) { \
    NSLog(@"DEBUG: %@:%@, %@", [self class], NSStringFromSelector(_cmd), [NSString stringWithFormat:__VA_ARGS__]); \
}

#endif
