//
//  SyncKitErrors.h
//  SyncKit
//
//  Created by Logan Collins on 12/20/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <SyncKit/SyncKitDefines.h>


SYNCKIT_EXTERN NSString * const SNKSyncKitErrorDomain;


enum {
    // Requests
    SNKInvalidRequestError      = 400,  // The request was rejected by the server.
    SNKNotAuthorizedError       = 401,  // The request did not contain valid credentials.
    
    // Responses
    SNKInvalidResponseError     = 1000, // The response from the server was invalid.
    
    // Sessions
    SNKSchemaDeprecatedError    = 2000, // The requested schema has been deprecated/disabled. The user should upgrade to a newer client version.
    
    // Core Data
    SNKUnsupportedPropertyMappingError  = 8000, // The coordinator was unable to map a record property onto a modelled property.
    SNKMissingRequiredValueError        = 8001, // The coordinator was unable to set a nil/empty value for a required property.
    SNKValidationError                  = 8002, // The coordinator was unable to validate the applied data.
};
